unit Demo1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, EnhTwain, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Interactive: TCheckBox;
    setup: TPanel;
    Label1: TLabel;
    PixelType: TComboBox;
    Label2: TLabel;
    BDReduction: TComboBox;
    Label3: TLabel;
    BitDepth: TComboBox;
    Label4: TLabel;
    resolution: TComboBox;
    Label5: TLabel;
    orientation: TComboBox;
    Label6: TLabel;
    PixelFlavor: TComboBox;
    scanner: TEnhTwain;
    Panel4: TPanel;
    Panel5: TPanel;
    ScrollBox1: TScrollBox;
    image: TImage;
    CBSource: TComboBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure scannerCapture(Sender: TObject);
    procedure InteractiveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure scannerLayout(sender: TObject; layout: PDCImageLayout);
    procedure FormShow(Sender: TObject);
    procedure Panel5Resize(Sender: TObject);
    procedure scannerCaptureCancel(Sender: TObject);
    procedure scannerCaptureFailure(Sender: TObject);
  private
    { Private declarations }
    CapaChecked:boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
if scanner.SelectSource then messagebeep(0);
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
scanner.source:='';
if CBSource.ItemIndex<>-1 then
  begin
  if CBSource.ItemIndex=0 then
    scanner.source:=''
  else
    scanner.source:=CBSource.items[CBSource.ItemIndex];
  end;  { if }
case PixelType.ItemIndex of
  0 : scanner.PixelType:=ptDefault;
  1 : scanner.PixelType:=ptBW;
  2 : scanner.PixelType:=ptGray;
  3 : scanner.PixelType:=ptRGB;
  4 : scanner.PixelType:=ptPalette;
  end;  { case }
case BDReduction.ItemIndex of
  0 : scanner.BDReduction:=bdrDefault;
  1 : scanner.BDReduction:=bdrThreshold;
  2 : scanner.BDReduction:=bdrHalftone;
  3 : scanner.BDReduction:=bdrDiffusion;
  end;  { case }
case BitDepth.ItemIndex of
  0 : scanner.BitDepth:=bdDefault;
  1 : scanner.BitDepth:=bd1;
  2 : scanner.BitDepth:=bd2;
  3 : scanner.BitDepth:=bd4;
  4 : scanner.BitDepth:=bd8;
  5 : scanner.BitDepth:=bd10;
  6 : scanner.BitDepth:=bd12;
  end;  { case }
case resolution.ItemIndex of
   0 : scanner.XRes:=0;
   1 : scanner.XRes:=25;
   2 : scanner.XRes:=50;
   3 : scanner.XRes:=75;
   4 : scanner.XRes:=100;
   5 : scanner.XRes:=150;
   6 : scanner.XRes:=200;
   7 : scanner.XRes:=300;
   8 : scanner.XRes:=400;
   9 : scanner.XRes:=500;
  10 : scanner.XRes:=600;
  end;  { case }
case resolution.ItemIndex of
   0 : scanner.YRes:=0;
   1 : scanner.YRes:=25;
   2 : scanner.YRes:=50;
   3 : scanner.YRes:=75;
   4 : scanner.YRes:=100;
   5 : scanner.YRes:=150;
   6 : scanner.YRes:=200;
   7 : scanner.YRes:=300;
   8 : scanner.YRes:=400;
   9 : scanner.YRes:=500;
  10 : scanner.YRes:=600;
  end;  { case }
case orientation.ItemIndex of
  0 : scanner.orientation:=orDefault;
  1 : scanner.orientation:=orPortrait;
  2 : scanner.orientation:=orRot90;
  3 : scanner.orientation:=orRot180;
  4 : scanner.orientation:=orLandscape;
  end;  { case }
case PixelFlavor.ItemIndex of
  0 : scanner.PixelFlavor:=pfDefault;
  1 : scanner.PixelFlavor:=pfChocolate;
  2 : scanner.PixelFlavor:=pfVanilla;
  end;  { case }
scanner.acquire(interactive.checked);
end;

procedure TForm1.scannerCapture(Sender: TObject);
begin
image.picture.assign(scanner.picture);
end;

procedure TForm1.InteractiveClick(Sender: TObject);
begin
setup.visible:=not interactive.checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
var x:integer;
begin
if scanner.sources.count=0 then
  begin
  MessageDlg('There is no TWAIN driver installed.',mtError,[mbOk],0);
  halt;
  end;  { if } 
CapaChecked:=false;
PixelType.ItemIndex  :=0;
BDReduction.ItemIndex:=0;
BitDepth.ItemIndex   :=0;
resolution.ItemIndex :=2;
orientation.ItemIndex:=0;
PixelFlavor.ItemIndex:=0;
CBSource.items.add('<default>');
for x:=0 to scanner.sources.count-1 do
  CBSource.items.add(scanner.sources[x]);
if CBSource.items.count>0 then CBSource.ItemIndex:=0;
end;

procedure TForm1.scannerLayout(sender: TObject; layout: PDCImageLayout);
begin
Layout^.frame.right .whole:=Layout^.frame.right .whole;
Layout^.frame.right .frac :=0;
Layout^.frame.bottom.whole:=Layout^.frame.bottom.whole div 3;
Layout^.frame.bottom.frac :=0;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
if not CapaChecked then
  begin
  if scanner.BitDepth   =bdNotSupported  then BitDepth   .enabled:=false;
  if scanner.BDReduction=bdrNotSupported then BDReduction.enabled:=false;
  if scanner.PixelType  =ptNotSupported  then PixelType  .enabled:=false;
  if scanner.orientation=orNotSupported  then orientation.enabled:=false;
  if scanner.PixelFlavor=pfNotSupported  then PixelFlavor.enabled:=false;
  CapaChecked:=true;
  end;  { if }
end;

procedure TForm1.Panel5Resize(Sender: TObject);
begin
CBSource.width:=panel5.width-CBSource.left*2;
end;

procedure TForm1.scannerCaptureCancel(Sender: TObject);
begin
ShowMessage('Capture cancelled');
end;

procedure TForm1.scannerCaptureFailure(Sender: TObject);
begin
ShowMessage('Capture failed');
end;

end.
